/**
 ******************************************************************************
 *
 * @file       uavobjecttemplate.cpp
 * @author     The OpenPilot Team, http://www.openpilot.org Copyright (C) 2010.
 * @brief      Template for an uavobject in java
 *             This is a autogenerated file!! Do not modify and expect a result.
 *             Status for the @ref AHRSCommsModule, including communication errors
 *
 * @see        The GNU Public License (GPL) Version 3
 *
 *****************************************************************************/
/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
 * for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 */

package org.openpilot.uavtalk.uavobjects;

import java.nio.ByteBuffer;
import java.util.ArrayList;
import java.util.List;
import java.util.ListIterator;

import org.openpilot.uavtalk.UAVObjectManager;
import org.openpilot.uavtalk.UAVObject;
import org.openpilot.uavtalk.UAVDataObject;
import org.openpilot.uavtalk.UAVObjectField;

/**
Status for the @ref AHRSCommsModule, including communication errors

generated from ahrsstatus.xml
 **/
public class AhrsStatus extends UAVDataObject {

	public AhrsStatus() {
		super(OBJID, ISSINGLEINST, ISSETTINGS, NAME);
		
		List<UAVObjectField> fields = new ArrayList<UAVObjectField>();
		

		List<String> SerialNumberElemNames = new ArrayList<String>();
		SerialNumberElemNames.add("0");
		SerialNumberElemNames.add("1");
		SerialNumberElemNames.add("2");
		SerialNumberElemNames.add("3");
		SerialNumberElemNames.add("4");
		SerialNumberElemNames.add("5");
		SerialNumberElemNames.add("6");
		SerialNumberElemNames.add("7");
		fields.add( new UAVObjectField("SerialNumber", "", UAVObjectField.FieldType.UINT8, SerialNumberElemNames, null) );

		List<String> CPULoadElemNames = new ArrayList<String>();
		CPULoadElemNames.add("0");
		fields.add( new UAVObjectField("CPULoad", "count", UAVObjectField.FieldType.UINT8, CPULoadElemNames, null) );

		List<String> RunningTimeElemNames = new ArrayList<String>();
		RunningTimeElemNames.add("0");
		fields.add( new UAVObjectField("RunningTime", "ms", UAVObjectField.FieldType.UINT32, RunningTimeElemNames, null) );

		List<String> IdleTimePerCyleElemNames = new ArrayList<String>();
		IdleTimePerCyleElemNames.add("0");
		fields.add( new UAVObjectField("IdleTimePerCyle", "10x ms", UAVObjectField.FieldType.UINT8, IdleTimePerCyleElemNames, null) );

		List<String> RunningTimePerCyleElemNames = new ArrayList<String>();
		RunningTimePerCyleElemNames.add("0");
		fields.add( new UAVObjectField("RunningTimePerCyle", "10x ms", UAVObjectField.FieldType.UINT8, RunningTimePerCyleElemNames, null) );

		List<String> DroppedUpdatesElemNames = new ArrayList<String>();
		DroppedUpdatesElemNames.add("0");
		fields.add( new UAVObjectField("DroppedUpdates", "count", UAVObjectField.FieldType.UINT8, DroppedUpdatesElemNames, null) );

		List<String> LinkRunningElemNames = new ArrayList<String>();
		LinkRunningElemNames.add("0");
		List<String> LinkRunningEnumOptions = new ArrayList<String>();
		LinkRunningEnumOptions.add("FALSE");
		LinkRunningEnumOptions.add("TRUE");
		fields.add( new UAVObjectField("LinkRunning", "", UAVObjectField.FieldType.ENUM, LinkRunningElemNames, LinkRunningEnumOptions) );

		List<String> AhrsKickstartsElemNames = new ArrayList<String>();
		AhrsKickstartsElemNames.add("0");
		fields.add( new UAVObjectField("AhrsKickstarts", "count", UAVObjectField.FieldType.UINT8, AhrsKickstartsElemNames, null) );

		List<String> AhrsCrcErrorsElemNames = new ArrayList<String>();
		AhrsCrcErrorsElemNames.add("0");
		fields.add( new UAVObjectField("AhrsCrcErrors", "count", UAVObjectField.FieldType.UINT8, AhrsCrcErrorsElemNames, null) );

		List<String> AhrsRetriesElemNames = new ArrayList<String>();
		AhrsRetriesElemNames.add("0");
		fields.add( new UAVObjectField("AhrsRetries", "count", UAVObjectField.FieldType.UINT8, AhrsRetriesElemNames, null) );

		List<String> AhrsInvalidPacketsElemNames = new ArrayList<String>();
		AhrsInvalidPacketsElemNames.add("0");
		fields.add( new UAVObjectField("AhrsInvalidPackets", "count", UAVObjectField.FieldType.UINT8, AhrsInvalidPacketsElemNames, null) );

		List<String> OpCrcErrorsElemNames = new ArrayList<String>();
		OpCrcErrorsElemNames.add("0");
		fields.add( new UAVObjectField("OpCrcErrors", "count", UAVObjectField.FieldType.UINT8, OpCrcErrorsElemNames, null) );

		List<String> OpRetriesElemNames = new ArrayList<String>();
		OpRetriesElemNames.add("0");
		fields.add( new UAVObjectField("OpRetries", "count", UAVObjectField.FieldType.UINT8, OpRetriesElemNames, null) );

		List<String> OpInvalidPacketsElemNames = new ArrayList<String>();
		OpInvalidPacketsElemNames.add("0");
		fields.add( new UAVObjectField("OpInvalidPackets", "count", UAVObjectField.FieldType.UINT8, OpInvalidPacketsElemNames, null) );


		// Compute the number of bytes for this object
		int numBytes = 0;
		ListIterator<UAVObjectField> li = fields.listIterator();
		while(li.hasNext()) {
			numBytes += li.next().getNumBytes();
		}
		NUMBYTES = numBytes;

		// Initialize object
		initializeFields(fields, ByteBuffer.allocate(NUMBYTES), NUMBYTES);
		// Set the default field values
		setDefaultFieldValues();
		// Set the object description
		setDescription(DESCRIPTION);
	}

	/**
	 * Create a Metadata object filled with default values for this object
	 * @return Metadata object with default values
	 */
	public Metadata getDefaultMetadata() {
		UAVObject.Metadata metadata = new UAVObject.Metadata();
		metadata.gcsAccess = UAVObject.AccessMode.ACCESS_READWRITE;
		metadata.gcsTelemetryAcked = UAVObject.Acked.FALSE;
		metadata.gcsTelemetryUpdateMode = UAVObject.UpdateMode.UPDATEMODE_MANUAL;
		metadata.gcsTelemetryUpdatePeriod = 0;

		metadata.flightAccess = UAVObject.AccessMode.ACCESS_READWRITE;
		metadata.flightTelemetryAcked = UAVObject.Acked.FALSE;
		metadata.flightTelemetryUpdateMode = UAVObject.UpdateMode.UPDATEMODE_PERIODIC;
		metadata.flightTelemetryUpdatePeriod = 1000;

		metadata.loggingUpdateMode = UAVObject.UpdateMode.UPDATEMODE_PERIODIC;
		metadata.loggingUpdatePeriod = 1000;
		return metadata;
	}

	/**
	 * Initialize object fields with the default values.
	 * If a default value is not specified the object fields
	 * will be initialized to zero.
	 */
	public void setDefaultFieldValues()
	{

	}

	/**
	 * Create a clone of this object, a new instance ID must be specified.
	 * Do not use this function directly to create new instances, the
	 * UAVObjectManager should be used instead.
	 */
	public UAVDataObject clone(int instID) {
		// TODO: Need to get specific instance to clone
		try {
			AhrsStatus obj = new AhrsStatus();
			obj.initialize(instID, this.getMetaObject());
			return obj;
		} catch  (Exception e) {
			return null;
		}
	}

	/**
	 * Static function to retrieve an instance of the object.
	 */
	public AhrsStatus GetInstance(UAVObjectManager objMngr, int instID)
	{
	    return (AhrsStatus)(objMngr.getObject(AhrsStatus.OBJID, instID));
	}

	// Constants
	protected static final int OBJID = 0x37A5F7A2;
	protected static final String NAME = "AhrsStatus";
	protected static String DESCRIPTION = "Status for the @ref AHRSCommsModule, including communication errors";
	protected static final boolean ISSINGLEINST = 1 == 1;
	protected static final boolean ISSETTINGS = 0 == 1;
	protected static int NUMBYTES = 0;


}